<template lang='pug'>
mixin prop(name)
  li #[strong.text-info= name+': ']
    block

Example(title='ExampleKeepFocusMixin' :maxState='1')
  template(v-slot:description)
    h5 This mixin will make your components able to keep the focus on elements
    p In particular, you can use this tool if the rendering process of your component
      |
      | is changing something in the dom and it makes your fields to lose the focus.
    p In the example proposed, press #[kbd Ctrl+E] to toggle Edit Mode.
    p Click on #[em code] to view and modify its code.
    p Click on #[em interface] to view the full specifications.

  template(v-slot:interface)
    h5 BaseKeepFocusMixin
    p You need to add #[code BaseKeepFocusMixin] to your component #[code mixins].
    p This mixin adds the following API to the component:
    ul
      +prop("keepFocusOnNextTick(ref: string): void")
        | If focus is on #[code vm.$refs.ref], it will call #[code vm.$nextTick()]
        |
        | and reset the focus back.
      +prop("saveFocusState(ref: string): void")
        | If focus is on #[code vm.$refs.ref], it will store it inside #[code vm.$options]
        |
        | This should be called before the animation starts.
      +prop("restoreFocusState(ref: string): void")
        | If focus is on #[code vm.$refs.ref], it will call #[code vm.$nextTick()]
        |
        | This should be called at the end of the animation.

  template(v-slot:code)
    template(v-pre).
      .row.justify-content-center.align-items-center.b-param-container
        BaseGlobalKeyboardEvent(:disableInputCheck="true" @ctrl-e-keydown="(e) => { e.preventDefault(); next() }")
        BaseParamDate.col-12.col-sm-4(:timestamp='1593259787' :inEdit='state !== 0'
          required="1" ref='valid' @edit='$refs.valid.checkValidity()')
          template(v-slot:title='p')
            | \#[strong Date] with keepFocus
        BaseParamInput.col-12.col-sm-4(:value='12' :inEdit='state !== 0')
          template(v-slot:title='p')
            | \#[strong Input] with keepFocus
        BaseParamList.col-12.col-sm-4(value='2' :inEdit='state !== 0' title='Param List')
          template(v-slot:options='')
            option(value="1") first
            option(value="2") second
            option(value="3") last
          template(v-slot:title='p')
            | \#[strong Param List] with keepFocus
</template>
<script>

import Example from "./AppExample.vue";

export default {
  name: "ExampleKeepFocusMixin",
  components: { Example }
};

</script>
